%module xml

%{
#include "libharkio3.h"
#include "libharkio3_macros.h"
#define HARKIO_LOG_INITIAL_LEVEL harkio_Log_Error

%}

harkio_XML* harkio_XML_new(void);
harkio_XML* harkio_XML_newFromXML(char *xmlpath, char *dtdpath);
harkio_XML* harkio_XML_newFromXMLbuffer(char *buffer, int strlen, char *dtdpath);
harkio_XML* harkio_XML_newFromData(harkio_Positions *ps, harkio_Neighbors *nbrs, harkio_Config *cfg);
void harkio_XML_delete(harkio_XML **xml);

harkio_Config*  harkio_XML_getConfig (harkio_XML *xml);

int harkio_XML_write(harkio_XML *xml, FILE *outstream);
int harkio_XML_writeHead(FILE *outstream);
int harkio_XML_writePositions(harkio_Positions *poses, FILE *outstream);
int harkio_XML_writeTail(FILE *outstream);

harkio_Neighbors *harkio_XML_getNeighbors(harkio_XML *xml);
harkio_Positions *harkio_XML_getPositions(harkio_XML *xml);
char* harkio_XML_writeBuffer(harkio_XML *xml);
